'                                  ESEMPIO.BAS
'
'       Esempio di utilizzazione delle procedure del file MASKT.BAS
'
'  versione 1.0                                                   rev. 06.90
'

' ------------------ Dichiarazione delle procedure utilizzate ------------------

' funzioni del file FUNZIONI.BAS
DECLARE FUNCTION RNUM$ (V!, L!)

' procedure del file MASKT.BAS
DECLARE SUB PaginaTf (Cod!(), Descr$(), Utst!(), JZ!, UR!(), UC!(), UL!(), UD$(), UU!, SWC!)

' procedure di questo stesso file
DECLARE SUB Pagina1 (Cod!(), Descr$(), Val1!, Val2!, Val3!, UU!)
DECLARE SUB Pagina2 (Cod!(), Descr$(), Val1$, Val2!, Val3!, Val4!, UU!)

' ------------------------------------------------------------------------------

DIM Cod(3), Descr$(3)
CONST TestoPagina = 7, SfondoPagina = 0

COLOR TestoPagina, SfondoPagina

' definizione del codice dei tasti funzione per la gestione delle pagine
' e della descrizione sintetica che deve comparire sullo schermo (7 caratteri)
Cod(1) = -81: Descr$(1) = "PagSucc"
Cod(2) = -73: Descr$(2) = "PagPrec"
Cod(3) = -81: Descr$(3) = "  Fine "

' assegnazione di valori iniziali alle variabili da definire nelle 2 pagine
V1 = 5
V2 = 12
V3 = 28
W$ = "nome"
W1 = 2
W2 = 45
W3 = 33.45

Pag = 1
DO
   SELECT CASE Pag
      CASE 1
         CALL Pagina1(Cod(), Descr$(), V1, V2, V3, UU)
         IF UU = 1 THEN Pag = 2
      CASE 2
         CALL Pagina2(Cod(), Descr$(), W$, W1, W2, W3, UU)
         IF UU = 1 THEN Pag = 1 ELSE Pag = 3
   END SELECT
LOOP UNTIL Pag = 3

END

' ================================ Pagina1 =====================================
'
'  Procedura per la gestione della prima pagina di dati
'
'  Variabili di ingresso:
'     Cod()     codici dei tasti funzione
'     Descr$()  descrizione dei tasti funzione
'     Val1, Val2, Val3  valore iniziale delle variabili da definire
'
'  Variabili di usita:
'     Val1, Val2, Val3  valore assegnato alle variabili
'     UU        numero d'ordine del tasto d'uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina1 (Cod(), Descr$(), Val1, Val2, Val3, UU)

   JZ = 3
   DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
   DIM Utst(7)
   '
   Utst(1) = 0
   Utst(2) = 0
   Utst(3) = 0
   Utst(4) = 0
   Utst(5) = 0
   Utst(6) = 1
   Utst(7) = 0
   '
   CLS
   LOCATE 5, 10: PRINT "Prima pagina"
   LOCATE 10, 2: PRINT "primo campo"
   LOCATE 12, 2: PRINT "secondo campo"
   LOCATE 14, 2: PRINT "terzo campo"
   '
   UR(1) = 10: UC(1) = 16: UL(1) = 6: UD$(1) = RNUM$(Val1, UL(1))
   UR(2) = 12: UC(2) = 16: UL(2) = 6: UD$(2) = RNUM$(Val2, UL(2))
   UR(3) = 14: UC(3) = 16: UL(3) = 6: UD$(3) = RNUM$(Val3, UL(3))
   '
   CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
   '
   IF SWC <> 0 THEN
      Val1 = VAL(UD$(1))
      Val2 = VAL(UD$(2))
      Val3 = VAL(UD$(3))
   END IF

END SUB

' ================================ Pagina2 =====================================
'
'  Procedura per la gestione della seconda pagina di dati
'
'  Variabili di ingresso:
'     Cod()     codici dei tasti funzione
'     Descr$()  descrizione dei tasti funzione
'     Val1$, Val2, Val3, Val4  valore iniziale delle variabili da definire
'
'  Variabili di usita:
'     Val1$, Val2, Val3, Val4  valore assegnato alle variabili
'     UU        numero d'ordine del tasto d'uscita premuto
'
' ------------------------------------------------------------------------------
SUB Pagina2 (Cod(), Descr$(), Val1$, Val2, Val3, Val4, UU)

   JZ = 4
   DIM UR(JZ), UC(JZ), UL(JZ), UD$(JZ)
   DIM Utst(7)
   '
   Utst(1) = 0
   Utst(2) = 0
   Utst(3) = 0
   Utst(4) = 0
   Utst(5) = 2
   Utst(6) = 0
   Utst(7) = 3
   '
   CLS
   LOCATE 5, 30: PRINT "----- Seconda pagina -----"
   LOCATE 10, 21: PRINT "primo campo"
   LOCATE 12, 21: PRINT "secondo campo"
   LOCATE 14, 21: PRINT "terzo campo"
   LOCATE 16, 21: PRINT "quarto campo"
   '
   UR(1) = 10: UC(1) = 37: UL(1) = 4: UD$(1) = Val1$
   UR(2) = 12: UC(2) = 36: UL(2) = 5: UD$(2) = RNUM$(Val2, UL(2))
   UR(3) = 14: UC(3) = 35: UL(3) = 6: UD$(3) = RNUM$(Val3, UL(3))
   UR(4) = 16: UC(4) = 34: UL(4) = 7: UD$(4) = RNUM$(Val4, UL(4))
   '
   CALL PaginaTf(Cod(), Descr$(), Utst(), JZ, UR(), UC(), UL(), UD$(), UU, SWC)
   '
   IF SWC <> 0 THEN
      Val1$ = UD$(1)
      Val2 = VAL(UD$(2))
      Val3 = VAL(UD$(3))
      Val4 = VAL(UD$(4))
   END IF

END SUB
